	FUNCTION COSMIC(ONESTAR,BIG,NOISE,NFAST,NSLOW,STARPAR)
	PARAMETER (MAXFIL = 1024)
	INCLUDE 'TUNEABLE3'
	COMMON /SUBRASTER/  Z(MAXFIL), XX(MAXFIL), YE(MAXFIL)
	COMMON /SEARCH/ NSTOT, THRESH
	COMMON /CRUDESTAT/ NPT, SUM1, SUMX, SUMY, MAXVAL
	COMMON/FITARRAYS/A(NPMAX),FA(NPMAX),C(2*NPMAX+1,2*NPMAX+1),
     1	B(2*NPMAX),FB(2*NPMAX)
	COMMON /UNITIZE/ UFACTOR
	DIMENSION STARPAR(NPMAX)
	EXTERNAL ONESTAR
	INTEGER*2 II(2)
	INTEGER*2 BIG(NFAST,NSLOW)
	INTEGER*4 NOISE(NFAST,NSLOW)
	LOGICAL POINTY, COSMIC
	EQUIVALENCE (II,R4)
	DATA MAGIC / 2147483647/
	COSMIC = .FALSE.
	POINTY = .FALSE.
	SKY = GUESS2(A, STARPAR, IX, IY)		
	MAXOB = -32768
	CHISTAR = 0
	CHICOS  = 0
	NPIX = 0
	DO 2757 KY = -1, 1
	  DO 2758 KX = -1, 1
	    IF		(IX+KX .GT. NFAST) THEN
	    ELSE IF	(IX+KX .LT. 1) THEN
	    ELSE IF	(IY+KY .GT. NSLOW) THEN
	    ELSE IF	(IY+KY .LT. 1) THEN
	    ELSE
	      II(1) = KX
	      II(2) = KY
	      IF (NOISE(IX+KX,IY+KY) .LT. MAGIC) THEN
		NPIX = NPIX + 1
		PRED = UFACTOR*ONESTAR(II,A,FA,NPMAX,NPMAX)
		IOBS =   BIG(IX+KX,IY+KY)
		TEMP = 1./NOISE(IX+KX,IY+KY)
		CHISTAR = CHISTAR + (IOBS - PRED)**2*TEMP
	        SN2 = (IOBS - SKY)**2*TEMP
		CHICOS  = CHICOS  + SN2
		IF (IOBS .LE. MAXOB) THEN
	        ELSE IF (SN2 .LT. SN2COS) THEN
	        ELSE
		  IMAX = IX + KX
		  JMAX = IY + KY
		  MAXOB = IOBS
		  TNOISE = TEMP
		END IF
	      END IF
	    END IF
2758	  CONTINUE
2757	CONTINUE
	IF (NPIX .LT. 7) THEN			
	ELSE IF (MAXOB .EQ. -32768) THEN	
	ELSE
	  CHICOS = CHICOS - (MAXOB - SKY)**2*TNOISE
	  POINTY = CHICOS .LT. DISCRIM*CHISTAR		
	if(lverb.gt.30) then
	    write(6,*) 'Location: ', IX, IY
	    write(6,*) 'CHI-STAR & CHI-COSMIC = ', CHISTAR, CHICOS
	end if
	END IF
	IF (POINTY) THEN
	if(lverb.gt.20) then
          write(6,*) 'COSMIC RAY INTENSITY, IX, IY : ',
     +        BIG(IMAX,JMAX),IMAX,JMAX
	end if
	  STARPAR(1) = SKY
	  STARPAR(2) = IMAX
	  STARPAR(3) = JMAX
	  STARPAR(4) = MAXOB
	  STARPAR(5) = WIDOBL
	  STARPAR(7) = WIDOBL
	  STARPAR(6) = -1
	END IF
	COSMIC = POINTY
	RETURN
	END
