	SUBROUTINE IMPROVE(ONESTAR,BIG,NOISE,NFAST,NSLOW)
	PARAMETER (MMAX = 11)
        include 'TUNEABLE3'
	PARAMETER (MAXFIL = 1024)
	PARAMETER (NAPPLE = 5)
	COMMON /APERLIST/ APPLE(NAPPLE ,NSMAX)
	COMMON /PROBPASS/ PROBG(NSMAX)
	COMMON /STARLIST/ STARPAR(NPMAX,NSMAX), IMTYPE(NSMAX)
	COMMON /SEARCH/ NSTOT,THRESH
	COMMON /SUBRASTER/  Z(MAXFIL), XX(MAXFIL), YE(MAXFIL)
	COMMON /CRUDESTAT/ NPT, SUM1, SUMX, SUMY, MAXVAL
	COMMON /FITARRAYS/ A(NPMAX), FA(NPMAX), C(NPMAX+1, NPMAX+1)
	COMMON /CTIMES / CHIIMP, APERTIME, FILLTIME, ADDTIME
	REAL*4 CC(5,5)
c-----------------------------------------------------------------------
c Array noise has been changed to a 32 bit integer array.
c       INTEGER*2 BIG(NFAST,NSLOW), NOISE(NFAST,NSLOW)
        integer*2 big(nfast, nslow)
        integer*4 noise(nfast, nslow)
c------------------------------------------------------------------------
	LOGICAL OFFPIC, SKIP, CONVERGE, SNOK, TRANSMASK
	EQUIVALENCE (C, CC)
	EXTERNAL ONESTAR
	DATA IADD, ISUB / 1, -1 /
        data pi / 3.14159265 /
C:
C:  NEXT WE GO THROUGH PREVIOUSLY IDENTIFIED STARS AND FIT AGAIN
C:
	I = 1
2757 	IF (I .LE. NSTOT) THEN
	  IF 		(IMTYPE(I) .EQ. 0) THEN
C	  ELSE IF	(IMTYPE(I) .EQ. 2) THEN
	  ELSE IF	(IMTYPE(I) .EQ. 6) THEN
	  ELSE IF	(IMTYPE(I) .EQ. 8) THEN
	  ELSE
	    CALLADDSTAR(ONESTAR,BIG,NOISE,NFAST,NSLOW,STARPAR(1,I),IADD)
	    SKY = GUESS3(A, STARPAR(1, I), IX, IY)
	 if(lverb.gt.20) then
	     write(6,*) ' IMPROVING STAR #', I, ' AT ', IX, IY
	 end if
	    CALL FILLERUP (BIG, NOISE, IX, IY, NFAST, NSLOW)
	    SNOK = TRANSMASK(BIG,NOISE,NFAST,NSLOW,IX,IY,SKY)
	    IF (SNOK) THEN
	      STARCHI=CHISQ(ONESTAR,XX,Z,YE,NPT,A,FA,C,NFIT1,ACC,
     *               ALIM,NIT)
	    ELSE
	  if(lverb.gt.20) write(6,*) ' STAR #,NPT,IX,IY = ', I,NPT,IX,IY
	    END IF
	    SKIP=.NOT.SNOK.OR.OFFPIC(A,IX,IY,NFAST,NSLOW,DX,DY)
	    IF (.NOT. SKIP) THEN
	      CONVERGE = STARCHI .LT. 9e9
	      IF (CONVERGE) THEN			
	        IF (IMTYPE(I) .NE. 2) THEN
		  CALL PARUPD (A, STARPAR(1,I), IX, IY)
                  totstar = 2*pi*starpar(4,i)*elarea(a(5),a(6),a(7))
                  varstar = totstar*eperdn
                  varsky = arect(1)*arect(2)*(sky*eperdn+rnoise**2)
                  if (varstar + varsky .gt. 0) then
                  errelec = sqrt(varstar + varsky)
                  errdn = errelec/eperdn
                  snpred = 1.086*errdn/totstar
                  if (snpred .lt. apmagmaxerr) then
		    CALL IMPAPER(BIG,NOISE,NFAST,NSLOW,I)
                  end if
                  end if
		  APPLE(4,I) = 1.086*CC(4,4)/A(4)
	        END IF
	        PROBG(I) = PROBGAL(ONESTAR, XX, Z, YE, NPT, A, FA)
	      ELSE
	        IF (IMTYPE(I) .NE. 3) IMTYPE(I) = 4	
	      END IF
	      CALLADDSTAR(ONESTAR,BIG,NOISE,NFAST,NSLOW,STARPAR(1,I),ISUB)
	    ELSE
	      IMTYPE(I) = 6	
	if(lverb.gt.20) then
	 write(6,*) ' DEACTIVATING STAR #', I, ' AT IX,IY = ',IX,IY
	end if
	    END IF
	  END IF
	  I = I + 1
	GO TO 2757
	END IF
	RETURN
	END
