	FUNCTION TWOFIT(TWOSTAR, STARPAR)
	PARAMETER (MMAX = 11)
	PARAMETER (MAXFIL = 1024)
        include 'TUNEABLE3'
	COMMON /SUBRASTER/  Z(MAXFIL), XX(MAXFIL), YE(MAXFIL)
	COMMON /CRUDESTAT/ NPT, SUM1, SUMX, SUMY, MAXVAL
	COMMON/FITARRAYS/A(NPMAX),FA(NPMAX),C(2*NPMAX+1,2*NPMAX+1),
     1	B(2*NPMAX),FB(2*NPMAX)
	COMMON /BYVIRTUE / CHI
	DIMENSION BACC(2*NPMAX),BLIM(2*NPMAX),STARPAR(NPMAX),CHI(4)
	EXTERNAL TWOSTAR
	LOGICAL BADFIT,CONV
	DATA IADD, ISUB / 1, -1 /
C:
C...SENSE IS THAT IF X IS LONG, ANGLE IS SMALL.
C...SENSE IS THAT IF X&Y ARE POSITIVELY CORRELATED, ANGLE IS POSITIVE.
C:
	BADFIT = .FALSE.
        CONV = .TRUE.
	CALL PARINTERP(STARPAR(2), STARPAR(3), AVA)
	IF (B(1) .EQ. 0) THEN
	  A5 = 1/A(5)
	  A7 = 1/A(7)
	  ANGLE = ATAN2(-2*A(6), A7 - A5)/2
	  ROOT = SQRT((A5 - A7)**2 + 4*A(6)**2)
	  ROOT1 = (A5 + A7 + ROOT)/2
	  ROOT2 = ROOT1 - ROOT
	  DX2 = A(5) - AVA(5)
	  DY2 = A(7) - AVA(7)
	  DX = SQRT(AMAX1(DX2,0.))/2
	  DY = SQRT(AMAX1(DY2,0.))/2
	  BADFIT = AMAX1(DX,DY) .EQ. 0
	  DX = SIGN(DX,COS(ANGLE))		
	  DY = SIGN(DY,SIN(ANGLE))
	  GAREA = 1/SQRT(ABS(ROOT1*ROOT2))      
	  SAREA = SQRT(ABS(AVA(5)*AVA(7)))      
	  DX74 = STARPAR(2) - A(2)		
	  DY74 = STARPAR(3) - A(3)		
	  DOT = DX74*DX + DY74*DY			
	  IF (DOT .GT. 0) THEN			
	    FAC1 = 0.6666666
	    FAC2 = 1.3333333
	  ELSE
	    FAC1 = 1.3333333
	    FAC2 = 0.6666666
	  END IF
	  B(1) = A(1)
	  B(2) = A(2) - DX*FAC1
	  B(3) = A(3) - DY*FAC1
	  B(4) = (A(4)*GAREA/SAREA/2*FAC2)		
	  B(5) = A(2) + DX*FAC2
	  B(6) = A(3) + DY*FAC2
	  B(7) = (A(4)*GAREA/SAREA/2*FAC1)		
	END IF
	B(4) = ALOG(B(4))
	B(7) = ALOG(B(7))
	B(8) = AVA(5)
	B(9) = AVA(6)
	B(10) = AVA(7)
	DO 2757 I = 1,4
	  BACC(I + 3) = ACC(I)
	  BACC(I) = ACC(I)
          BLIM(I + 3) = ALIM(I)
          BLIM(I) = ALIM(I)
2757	CONTINUE
	BACC(4) = -.01					
	BACC(7) = -.01					
        BLIM(4) = -10.0					
        BLIM(7) = -10.0                                 
	DXMAX = AMAX1(ABS(B(2)),ABS(B(5)))
	DYMAX = AMAX1(ABS(B(3)),ABS(B(6)))
	BADFIT = BADFIT .OR. (DXMAX .GT. IRECT(1)/2.)
	BADFIT = BADFIT .OR. (DYMAX .GT. IRECT(2)/2.)
	IF ( .NOT. BADFIT) THEN		
      TWOFIT = CHISQ(TWOSTAR,XX,Z,YE,NPT,B,FB,C,NFIT2,BACC,BLIM,
     1	2*NIT)
          CONV = TWOFIT .LT. 1E10
	END IF
	DXMAX = AMAX1(ABS(B(2)),ABS(B(5)))
	DYMAX = AMAX1(ABS(B(3)),ABS(B(6)))
	BADFIT = BADFIT .OR. (DXMAX .GT. IRECT(1)/2. + 1)
	BADFIT = BADFIT .OR. (DYMAX .GT. IRECT(2)/2. + 1)
      IF( CONV ) THEN
	IF (B(4) .LT. B(7)) THEN
	  DO 2758 I = 2, 4			
	    FB(I) = B(I)
	    B(I)  = B(I + 3)
	    B(I + 3)  = FB(I)
2758	  CONTINUE
	END IF
	B(4) = EXP(B(4))				
	B(7) = EXP(B(7))				
	DO 2759 I = 1, 7
	  FB(I) = B(I)					
2759	CONTINUE
	B(8) = B(1)
	B(9) = B(5)
	B(10) = B(6)
	B(11) = B(7)
	DO 2760 I = 5,7
	  B(I) = AVA(I)
	  B(I + 7) = AVA(I)
2760	CONTINUE
      END IF
      IF (.NOT. CONV .OR. BADFIT) TWOFIT = 1.0E20
	RETURN
	END
