procedure errmsg (pattern)

string	pattern				{prompt="MATCH style pattern string"}

bool	meta     = yes			{prompt="Recognize metacharacters?"}
bool	symbolic = no			{prompt="Match symbolic code names?"}

string	msgfile  = "lib$syserrmsg"	{prompt="File containing messages"}
string	codefile = "lib$syserr.h"	{prompt="File containing error codes"}

string	*list1
string	*list2

begin
	string	blanks = "                    "

	string	lpattern, tmp1, tmp2, value, code, junk, white
	bool	firstpass

	string	msg1, msg2		# work around 62 char struct limit
	struct	msgtail

	tmp1 = mktemp ("tmp$tmp")
	tmp2 = mktemp ("tmp$tmp")

	lpattern = pattern

	if (symbolic) {
	    match (lpattern, codefile, stop-, metacharacters=meta, > tmp1)

	    list1 = tmp1
	    while (fscan (list1, junk, code, value) != EOF)
		if (junk != "#") {
		    match (value, msgfile, stop-, metacharacters-, > tmp2)

		    firstpass = yes

		    list2 = tmp2
		    while (fscan (list2, junk, msg1, msg2, msgtail) != EOF) {
			if (junk == "#")
			    next

			if (! firstpass)
			    print ("\n\tWarning!  Duplicate error code in `",
				msgfile, "':\n")

			white = substr (blanks, 1, 20 - strlen(code))
			print (value, "  ", code, white,
			    msg1, " ", msg2, " ", msgtail)

			firstpass = no
		    }

		    list2 = ""
		    delete (tmp2, ver-, >& "dev$null")
		}

	} else {
	    match (lpattern, msgfile, stop-, metacharacters=meta, > tmp1)

	    list1 = tmp1
	    while (fscan (list1, value, msg1, msg2, msgtail) != EOF)
		if (value != "#") {
		    match (value, codefile, stop-, metacharacters-, > tmp2)

		    firstpass = yes

		    list2 = tmp2
		    while (fscan (list2, junk, code) != EOF) {
			if (junk == "#")
			    next

			if (! firstpass)
			    print ("\n\tWarning!  Duplicate error code in `",
				codefile, "':\n")

			white = substr (blanks, 1, 20 - strlen(code))
			print (value, "  ", code, white,
			    msg1, " ", msg2, " ", msgtail)

			firstpass = no
		    }

		    list2 = ""
		    delete (tmp2, ver-, >& "dev$null")
		}

	}

	list1 = ""
	delete (tmp1, ver-, >& "dev$null")
end
