include	<mach.h>
include	<gset.h>
include	<gio.h>
include	"lblglabax.h"

# LBL_VERIFY_LOG_SCALING -- Verify that log scaling makes sense.  Taken
# almost entirely from gio$glabax/glbverify.x (which see), with only minor
# modifications.

procedure lbl_verify_log_scaling (gp)

pointer	gp			# graphics descriptor

int	xtran, ytran
real	wxmin, wxmax, wymin, wymax

int	gstati()

#debug+
int	debug
common /deb/ debug
#debug-
begin
	xtran = gstati (gp, G_XTRAN)
	ytran = gstati (gp, G_YTRAN)
	call ggwind (gp, wxmin, wxmax, wymin, wymax)

	# Force ELOG scaling if any data <= 0.

	if (xtran != LINEAR)
	    if (wxmin <= 0 || wxmax <= 0)
		call gseti (gp, G_XTRAN, ELOG)

	if (ytran != LINEAR)
	    if (wymin <= 0 || wymax <= 0)
		call gseti (gp, G_YTRAN, ELOG)

end
