include "lpl.h"

# LPL_INIT_ORIGINAL -- Initialize static parameters describing the initial
# state of the 10 world & plotter ranges and the specified world/plotter scales.

procedure lpl_init_original (lpl)

pointer	lpl			# longplot descriptor

begin
	LPL_MAJRX_INDEF(lpl) = NO
	LPL_MAJRY_INDEF(lpl) = NO
	LPL_WXMIN_INDEF(lpl) = NO
	LPL_WXMAX_INDEF(lpl) = NO
	LPL_WYMIN_INDEF(lpl) = NO
	LPL_WYMAX_INDEF(lpl) = NO
	LPL_PXMIN_INDEF(lpl) = NO
	LPL_PXMAX_INDEF(lpl) = NO
	LPL_PYMIN_INDEF(lpl) = NO
	LPL_PYMAX_INDEF(lpl) = NO
	LPL_XSCALE_INDEF(lpl) = NO
	LPL_YSCALE_INDEF(lpl) = NO

	if (LPL_MAJRX(lpl) < 0)
	    LPL_MAJRX_INDEF(lpl) = YES

	if (LPL_MAJRY(lpl) < 0)
	    LPL_MAJRY_INDEF(lpl) = YES

	if (IS_INDEF(LPL_WXMIN(lpl)))
	    LPL_WXMIN_INDEF(lpl) = YES

	if (IS_INDEF(LPL_WXMAX(lpl)))
	    LPL_WXMAX_INDEF(lpl) = YES

	if (IS_INDEF(LPL_WYMIN(lpl)))
	    LPL_WYMIN_INDEF(lpl) = YES

	if (IS_INDEF(LPL_WYMAX(lpl)))
	    LPL_WYMAX_INDEF(lpl) = YES

	if (IS_INDEF(LPL_PXMIN(lpl)))
	    LPL_PXMIN_INDEF(lpl) = YES

	if (IS_INDEF(LPL_PXMAX(lpl)))
	    LPL_PXMAX_INDEF(lpl) = YES

	if (IS_INDEF(LPL_PYMIN(lpl)))
	    LPL_PYMIN_INDEF(lpl) = YES

	if (IS_INDEF(LPL_PYMAX(lpl)))
	    LPL_PYMAX_INDEF(lpl) = YES

	if (IS_INDEF(LPL_XSCALE(lpl)))
	    LPL_XSCALE_INDEF(lpl) = YES

	if (IS_INDEF(LPL_YSCALE(lpl)))
	    LPL_YSCALE_INDEF(lpl) = YES
end
