# LPL_INVERT -- Given a series of newline-separated titles, invert their
# order so that the first title appears at the bottom.

procedure lpl_invert (title_str)

char	title_str[ARB]

int	ip, op
pointer	sp, out

int	strlen(), strldx()

begin
	call smark (sp)
	call salloc (out, SZ_LINE*4, TY_CHAR)
	call amovkc (EOS, Memc[out], SZ_LINE*4)

	# Start at the end of the input string, locate the first \n going
	# backwards, copy that titlespec into the output string, etc.

	ip = strldx ('\n', title_str)
	op = 1
	while (ip > 0) {
	    call strcpy (title_str[ip+1], Memc[out+op-1], SZ_LINE*4)
	    op = strlen (Memc[out]) + 1
	    Memc[out+op-1] = '\n'
	    op = op + 1
	    title_str[ip] = EOS
	    ip = strldx ('\n', title_str)
	}

	# Last one.
	call strcpy (title_str[1], Memc[out+op-1], SZ_LINE*4)
	op = strlen (Memc[out]) + 1
	Memc[out+op-1] = EOS
	call strcpy (Memc[out], title_str, SZ_LINE*4)
	
	op = strlen (title_str)
	call amovkc (EOS, title_str[op+1], SZ_LINE*4 - op)

	call sfree (sp)
end
