include <ctype.h>

# LPL_NEXTINPUT -- Get the next input_spec string from the input list.  
# Input_spec strings are delimited by commas.  Cannot use CLGFIL because the
# image section notation conflicts with the pattern matching metacharacters.

int procedure lpl_nextinput (inlist, ip, outstr, maxch)

char	inlist[ARB]
int	ip
char	outstr[maxch]
int	maxch

char	ch
bool	in_section
int	op

begin
	while (IS_WHITE(inlist[ip]) || inlist[ip] == ',')
	    ip = ip + 1

	ch = inlist[ip]
	op = 1
	in_section = false

	while (ch != EOS) {
	    if (ch == '[')
		in_section = true
	    else if (ch == ']')
		in_section = false
	    else if (ch == ',' && !in_section)
		break
	    if (!IS_WHITE(ch)) {
		outstr[op] = ch
		op = min (maxch, op + 1)
	    }
	    ip = ip + 1
	    ch = inlist[ip]
	}
	outstr[op] = EOS

	return (op-1)
end
