include <gescape.h>
include	<mach.h>
include "lpl.h"

# LPL_SET_EXACT -- Place kernel-dependent exact-scaling command into metacode.

procedure lpl_set_exact (lpl, gd, xscale, yscale)

pointer	lpl			# longplot descriptor
pointer	gd			# graphics descriptor
real	xscale,yscale		# scales in device units / GKI unit

int	nwords
char	cscale[MAX_SCALEWORDS]
short	sscale[MAX_SCALEWORDS]

int	dtoc()

begin
	# If exact-scaling, send x scale to plotter.
	if (!IS_INDEF(xscale)) {
	    nwords = dtoc (xscale, cscale, MAX_SCALEWORDS, NDIGITS_RP, 'g',
		MAX_SCALEWORDS)
	    call achtcs (cscale, sscale, nwords)
	    call gescape (gd, GSC_X_GKITODEV, sscale, nwords)
	}

	# If exact-scaling, send y scale to plotter.
	if (!IS_INDEF(yscale)) {
	    nwords = dtoc (yscale, cscale, MAX_SCALEWORDS, NDIGITS_RP, 'g',
		MAX_SCALEWORDS)
	    call achtcs (cscale, sscale, nwords)
	    call gescape (gd, GSC_Y_GKITODEV, sscale, nwords)
	}
end
