# Arrays for holding actual world, plotter, viewport, and 2 kinds of scales
# necessary to accommodate stacked plotting.  Not strictly necessary to
# allocate these dynamically, but helpful for large ncurves, and makes program
# more flexible for future modification.

define	LEN_LPX			30
define	LPMEM_LINETYPE		Memi[$1]
define	LPMEM_MAJRX		Memi[$1+1]
define	LPMEM_MAJRY		Memi[$1+2]
define	LPMEM_MARKERSIZE	Memi[$1+3]
define	LPMEM_MARKERTYPE	Memi[$1+4]
define	LPMEM_MINRX		Memi[$1+5]
define	LPMEM_MINRY		Memi[$1+6]
define	LPMEM_PXMIN		Memi[$1+7]
define	LPMEM_PXMAX		Memi[$1+8]
define	LPMEM_PXSCALE		Memi[$1+9]
define	LPMEM_PYMIN		Memi[$1+10]
define	LPMEM_PYMAX		Memi[$1+11]
define	LPMEM_PYSCALE		Memi[$1+12]
define	LPMEM_VXMIN		Memi[$1+13]
define	LPMEM_VXMAX		Memi[$1+14]
define	LPMEM_VYMIN		Memi[$1+15]
define	LPMEM_VYMAX		Memi[$1+16]
define	LPMEM_WXMIN		Memi[$1+17]
define	LPMEM_WXMAX		Memi[$1+18]
define	LPMEM_WYMIN		Memi[$1+19]
define	LPMEM_WYMAX		Memi[$1+20]
define	LPMEM_WXSCALE		Memi[$1+21]
define	LPMEM_WYSCALE		Memi[$1+22]
				# extra space

define	LPX_LINETYPE		Memi[LPMEM_LINETYPE($1)+$2]
define	LPX_MAJRX		Memi[LPMEM_MAJRX($1)+$2]
define	LPX_MAJRY		Memi[LPMEM_MAJRY($1)+$2]
define	LPX_MARKERSIZE		Memr[LPMEM_MARKERSIZE($1)+$2]
define	LPX_MARKERTYPE		Memi[LPMEM_MARKERTYPE($1)+$2]
define	LPX_MINRX		Memi[LPMEM_MINRX($1)+$2]
define	LPX_MINRY		Memi[LPMEM_MINRY($1)+$2]
define	LPX_PXMIN		Memr[LPMEM_PXMIN($1)+$2]
define	LPX_PXMAX		Memr[LPMEM_PXMAX($1)+$2]
define	LPX_PXSCALE		Memr[LPMEM_PXSCALE($1)+$2]
define	LPX_PYMIN		Memr[LPMEM_PYMIN($1)+$2]
define	LPX_PYMAX		Memr[LPMEM_PYMAX($1)+$2]
define	LPX_PYSCALE		Memr[LPMEM_PYSCALE($1)+$2]
define	LPX_VXMIN		Memr[LPMEM_VXMIN($1)+$2]
define	LPX_VXMAX		Memr[LPMEM_VXMAX($1)+$2]
define	LPX_VYMIN		Memr[LPMEM_VYMIN($1)+$2]
define	LPX_VYMAX		Memr[LPMEM_VYMAX($1)+$2]
define	LPX_WXMIN		Memr[LPMEM_WXMIN($1)+$2]
define	LPX_WXMAX		Memr[LPMEM_WXMAX($1)+$2]
define	LPX_WYMIN		Memr[LPMEM_WYMIN($1)+$2]
define	LPX_WYMAX		Memr[LPMEM_WYMAX($1)+$2]
define	LPX_WXSCALE		Memr[LPMEM_WXSCALE($1)+$2]
define	LPX_WYSCALE		Memr[LPMEM_WYSCALE($1)+$2]
