procedure queue (queue)

string	queue		{prompt="Queue name"}
bool	long	= no	{prompt="Long format output?"}
bool	repeat	= no	{prompt="Repeat until queue empties?"}
int	interval= 5	{prompt="Repetition interval (seconds)",min=1}

begin
	string	printer, stdplot, q, options

	printer = envget ("printer")
	stdplot = envget ("stdplot")

	if ($nargs == 0)
	    q = printer
	else
	    q = queue

	if (q == printer)
	    print ("\nchecking queue = " // q // "\n")
	else
	    print ("\nchecking queue = " // q // "   ",
		"(printer=" // printer // ",",
		" stdplot=" // stdplot // ")\n")

	if (long)
	    options = " -l "
	else
	    options = " "

	if (repeat)
	    options = options // "+" // str (interval) // " "

	options = options // "-P" // q

	print ("!lpq" // options) | cl
end
