# Prepend line numbers to a file

procedure t_linenum()

pointer	infile, outfile, outstr, sp
int	inlist, outlist, nout, fdin, fdout
int	line, incr, junk

int	clpopni(), clpopns(), clgfil(), clplen(), clgeti(), open(), fscan()

begin
	call smark (sp)
	call salloc (infile, SZ_FNAME, TY_CHAR)
	call salloc (outfile, SZ_FNAME, TY_CHAR)
	call salloc (outstr, SZ_LINE, TY_CHAR)

	inlist = clpopni ("input")

	if (clgeti ("$nargs") >= 2) {
	    outlist = clpopns ("output")
	    nout = clplen (outlist)
	    if (nout == 1) {
		junk = clgfil (outlist, Memc[outfile], SZ_FNAME)
		call clpcls (outlist)
	    }
	} else {
	    call strcpy ("STDOUT", Memc[outfile], SZ_FNAME)
	    nout = 1
	}

	if (nout != 1 && nout != clplen (inlist)) {
	    call clpcls (inlist)
	    call clpcls (outlist)
	    call sfree (sp)
	    call error (1, "Input and output lists don't match")
	}

	line = clgeti ("first_line")
	incr = clgeti ("increment")

	while (clgfil (inlist, Memc[infile], SZ_FNAME) != EOF) {
	    if (nout != 1)
		junk = clgfil (outlist, Memc[outfile], SZ_FNAME)

	    fdin = open (Memc[infile], READ_ONLY, TEXT_FILE)
	    fdout = open (Memc[outfile], APPEND, TEXT_FILE)

	    while (fscan(fdin) != EOF) {
		call gargstr (Memc[outstr], SZ_LINE)
		call fprintf (fdout, "%5d %s\n")
		    call pargi (line)
		    call pargstr (Memc[outstr])

		line = line + incr
	    }

	    call close (fdin)
	    call close (fdout)
	}

	call clpcls (inlist)
	if (nout != 1)
	    call clpcls (outlist)
	call sfree (sp)
end
