      SUBROUTINE PLOT(XPAG ,YPAG ,IPEN)                                 
CALCOMP  PRODUCT NUMBER  411010*2-G              EBCDIC PUNCH           
CALCOMP HCBS FOR CDC-6000     906/EM RS-232 ONLINE          JUL, 1979 * 
CALCOMP  COPYRIGHT 1979 CALIFORNIA COMPUTER PRODUCTS INC.               
      REAL XMAX
      CHARACTER*33 HEADER
      COMMON /HEAD1/HEADER
      COMMON /HEAD2/XMAX
C
C.THE FOLLOWING DATA DEFINITIONS ARE ONLY EXECUTED THE FIRST TIME PLOT IS CALLED
C
      DATA IOP/3/,ISA/1/,IPFG/0/                                        
     *  ,INDEX/2/                                                       
      DATA DPX/32767.0/                                                 
     *  ,XSTP,YSTP,STEPS/3*508.0/                                       
     *  ,XMAX,YMAX/2*0.0/                                               
      DATA XOX,YOY/0.0,0.0/                                             
      DATA FRM0,FRM1/2*0./
C..................................SAVE INPUT
      XP=XPAG*XSTP                                                      
      YP=YPAG*YSTP                                                      
      IP=IPEN                                                           
C
C...............................CHECK TO ATTEMPT TO PLOT AHEAD OF STARTING POINT
      IF (ABS(IP).LE.3) THEN
         IF ((FRM1+XP).LT.0.) THEN
            CALL ERR(' ERROR:  ATTEMPT TO PLOT AHEAD OF STARING POINT')
            RETURN
         ENDIF
      ENDIF
C     CHECK FOR SPECIAL ENTRANCE                                        
      IF(IABS(IP)-999)100,150,600                                       
  100 IPFG=0                                                            
C     CHECK FOR VARIOUS IPEN FUNCTIONS                                  
      IF(IP)110,120,120                                                 
C     IF IPEN NEGATIVE  REORIGIN                                        
  110 IP=-IP                                                            
      IPFG=-10                                                          
C     CHECK FOR IPEN BETWEEN 30 & 39                                    
  120 IF (IP-30)  200,130,130                                           
  130 IF (IP-40)  140,200,200                                           
  140 IP = IP-30                                                        
      IPFG = IPFG-1                                                     
      GO TO 200                                                         
C     ASSUME IPEN IS 999                                                
  150 IP=3                                                              
      IPFG = -99                                                        
C  AT END OF PLOT MOVE TO END OF AREA PLOTTED.                          
      XP=XMAX                                                           
     *  +4.0*XSTP                                                       
      YP=0.0                                                            
C  INCREMENT SEARCH ADDRESS BY 64**2 FOR A PLOT(X,Y,999) CALL.          
C  S.A. IS WRITTEN AS A*64**2+B*64+C.                                   
      ISA=ISA+64*64                                                     
C     CHECK FOR PEN CHANGE                                              
  200 IF(IP-IOP)210,300,210                                             
C     CHECK FOR PEN DOWN                                                
  210 IF(IP-2)300,220,230                                               
C     PEN DOWN                                                          
  220 IOP=2                                                             
      CALL BUFF(2,1,0)                                                  
      GO TO 300                                                         
C     PEN UP                                                            
  230 IOP=3                                                             
      CALL BUFF(3,1,0)                                                  
  300 XDX=XP-XOX                                                        
      YDY=YP-YOY                                                        
C.................................ROUND OFF TO PLOTTER RESOLUTION
      XDX=XDX+SIGN(.5,XDX)                                              
      YDY=YDY+SIGN(.5,YDY)                                              
      ADX=ABS(XDX)                                                      
      ADY=ABS(YDY)                                                      
      IF(ADX-DPX) 350,350,310                                           
  310 IF(ADX-ADY) 320,320,330                                           
  320 DIV=ADY/DPX                                                       
      GO TO 340                                                         
  330 DIV=ADX/DPX                                                       
  340 IDX=XDX/DIV                                                       
      IDY=YDY/DIV                                                       
C          SEND OUT PART OF THE REQUESTED MOVE                          
      CALL BUFF(IDX,IDY,2)                                              
      XOX = XOX + FLOAT(IDX)                                            
      YOY = YOY + FLOAT(IDY)                                            
      GO TO 300                                                         
C     SEND OUT LAST PART OF LINE                                        
  350 IF (ADY-DPX) 360,360,320                                          
  360 IDX=XDX                                                           
      IDY=YDY                                                           
      CALL BUFF(IDX,IDY,2)                                              
      XOX = XOX + FLOAT(IDX)                                            
      YOY = YOY + FLOAT(IDY)                                            
      XMAX=AMAX1(XMAX,XOX)                                              
      YMAX=AMAX1(YMAX,YOY)                                              
      FRM1=FRM0+XMAX
C     CHECK AT END FOR VARIOUS IPEN FUNCTIONS                           
  450 IF(IPFG+1) 460,470,999                                            
C     REORIGN, DUMP BUFFER, AND OUTPUT S.A.                             
  460 XOX=0.0                                                           
      YOY=0.0                                                           
C     CHECK FOR OUTPUT OF INDEX COMMAND                                 
      IF (INDEX-1)  490,480,470                                         
  470 IF (IPFG+99)  490,480,490                                         
C     OUTPUT INDEX COMMAND                                              
480   CONTINUE                                                          
C  DON"T ISSUE INDEX COMMAND TO 1038.                                   
C     DUMP BUFFER AND WRITE NEXT S.A.                                   
  490 CALL BUFF(0,0,5)                                                  
      CALL BUFF(1,1,0)                                                  
      CALL BUFF(ISA,3,7)                                                
      ISA = ISA+1                                                       
C  RESET X,Y MAX                                                        
      XMAX=0.0                                                          
      YMAX=0.0                                                          
      FRM0=FRM1
C     CHECK FOR IPEN = 999                                              
      IF (IPFG+99) 999,500,999                                          
  500 CALL BUFF(0,0,5)                                                  
      CALL BUFF(0,0,1)                                                  
C
C SEND THE PLOT TO THE QUEUE.
C
      CALL CWRITC()
  999 RETURN                                                            
C                              CHECK FOR SPECIAL PLOT ENTRIES           
  600 IP=IP-1000                                                        
      IF(IP-7)610,610,999                                               
  610 GO TO(1001,1002,1003,1004,1005,1006,1007),IP                      
C                                                       FACTOR          
 1001 XSTP=XPAG*STEPS                                                   
      YSTP=YPAG*STEPS                                                   
      GO TO 999                                                         
C                                                       WHERE           
 1002 XPAG=XOX/XSTP                                                     
      YPAG=YOY/YSTP                                                     
      GO TO 999                                                         
 1003 XPAG=XSTP/STEPS                                                   
      YPAG=YSTP/STEPS                                                   
      GO TO 999                                                         
C                                                        NEWPEN         
 1004 IOP = 3                                                           
      GO TO 999                                                         
C                                         SYMBOL FIND STEP SIZE         
 1005 XPAG=XSTP                                                         
      YPAG=YSTP                                                         
      GO TO 999                                                         
C                           SYMBOL ADVANCE CURRENT PEN POSITION         
 1006 XOX=XOX+XPAG                                                      
      YOY=YOY+YPAG                                                      
      IOP=3                                                             
      XMAX=AMAX1(XMAX,XOX)                                              
      YMAX=AMAX1(YMAX,YOY)                                              
      FRM1=FRM0+XMAX
      GO TO 999                                                         
C                                                        PLOTS          
 1007 IF (XPAG) 1027,1027,1017                                          
 1017 N = MIN0(32,IFIX(XPAG))                                           
      STEPS = STEPS/N                                                   
      XSTP = STEPS                                                      
      YSTP = STEPS                                                      
      DPX = DPX  / N                                                    
      CALL BUFF(2,0,6)                                                  
      CALL BUFF(9,1,0)                                                  
      CALL BUFF(N,1,0)                                                  
 1027 IF (YPAG) 490,490,1037                                            
 1037 INDEX = YPAG                                                      
      GO TO 490                                                         
      END                                                               
