      SUBROUTINE AXIS(XPAGE,YPAGE,IBCD,NCHAR,AXLEN,ANGLE,FIRSTV,DELTAV) 
CALCOMP  PRODUCT NUMBER  411010*2-G              EBCDIC PUNCH           
CALCOMP HCBS FOR CDC-6000     906/EM RS-232 ONLINE          JUL, 1979 * 
CALCOMP  COPYRIGHT 1979 CALIFORNIA COMPUTER PRODUCTS INC.               
C.....     XPAGE,YPAGE  COORDINATES OF STARTING POINT OF AXIS, IN INCHES
C.....     IBCD         AXIS TITLE.                                     
C.....     NCHAR        NUMBER OF CHARACTERS IN TITLE. + FOR C.C-W SIDE.
C.....     AXLEN        FLOATING POINT AXIS LENGTH IN INCHES.           
C.....     ANGLE        ANGLE OF AXIS FROM THE X-DIRECTION, IN DEGREES. 
C.....     FIRSTV       SCALE VALUE AT THE FIRST TIC MARK.              
C.....     DELTAV       CHANGE IN SCALE BETWEEN TIC MARKS ONE INCH APART
      DIMENSION IBCD(2)                                                 
      KN=NCHAR                                                          
      A=1.0                                                             
      IF (KN) 1,2,2                                                     
  1   A=-A                                                              
      KN=-KN                                                            
  2   EX=0.0                                                            
      ADX= ABS  (DELTAV)                                                
      IF (ADX) 3,7,3                                                    
  3   IF (ADX- 99.0) 6,4,4                                              
  4   ADX=ADX/10.0                                                      
      EX=EX+1.0                                                         
      GO TO 3                                                           
  5   ADX=ADX*10.0                                                      
      EX=EX-1.0                                                         
  6   IF (ADX-0.01) 5,7,7                                               
  7   XVAL=FIRSTV*10.0**(-EX)                                           
      ADX= DELTAV*10.0**(-EX)                                           
      STH=ANGLE*0.0174533                                               
      CTH=COS(STH)                                                      
      STH=SIN(STH)                                                      
      DXB=-0.1                                                          
      DYB=0.15*A-0.05                                                   
      XN=XPAGE+DXB*CTH-DYB*STH                                          
      YN=YPAGE+DYB*CTH+DXB*STH                                          
      NTIC=AXLEN+1.0                                                    
      NT=NTIC/2                                                         
      DO  20  I=1,NTIC                                                  
        CALL NUMBER(XN,YN,0.105,XVAL,ANGLE,2)                           
        XVAL=XVAL+ADX                                                   
        XN=XN+CTH                                                       
        YN=YN+STH                                                       
        IF (NT) 20,11,20                                                
 11       Z=KN                                                          
          IF (EX)  12,13,12                                             
 12       Z=Z+7.0                                                       
 13       DXB=-.07*Z+AXLEN*0.5                                          
          DYB=0.325*A-0.075                                             
          XT=XPAGE+DXB*CTH-DYB*STH                                      
          YT=YPAGE+DYB*CTH+DXB*STH                                      
          CALL SYMBOL(XT,YT,0.14,IBCD(1),ANGLE,KN)                      
          IF (EX)  14,20,14                                             
 14         Z=KN+2                                                      
            XT=XT+Z*CTH*0.14                                            
            YT=YT+Z*STH*0.14                                            
            CALL SYMBOL(XT,YT,0.14,3H*10,ANGLE,3)                       
            XT=XT+(3.0*CTH-0.8*STH)*0.14                                
            YT=YT+(3.0*STH+0.8*CTH)*0.14                                
            CALL NUMBER(XT,YT,0.07,EX,ANGLE,-1)                         
 20   NT=NT-1                                                           
      CALL PLOT(XPAGE+AXLEN*CTH,YPAGE+AXLEN*STH,3)                      
      DXB=-0.07*A*STH                                                   
      DYB=+0.07*A*CTH                                                   
      A=NTIC-1                                                          
      XN=XPAGE+A*CTH                                                    
      YN=YPAGE+A*STH                                                    
      DO  30  I=1,NTIC                                                  
        CALL PLOT(XN,YN,2)                                              
        CALL PLOT(XN+DXB,YN+DYB,2)                                      
        CALL PLOT(XN,YN,2)                                              
        XN=XN-CTH                                                       
        YN=YN-STH                                                       
 30   CONTINUE                                                          
      RETURN                                                            
      END                                                               
