      SUBROUTINE BUFF(IDX,IDY,MODE)
C
	CHARACTER*4 CH4
	INTEGER ICH4
	EQUIVALENCE (CH4,ICH4)
C
CALCOMP  PRODUCT NUMBER  411010*2-G              EBCDIC PUNCH
CALCOMP HCBS FOR CDC 6000     906/EM RS-232 ONLINE          JUL, 1979 *
CALCOMP  COPYRIGHT 1979 CALIFORNIA COMPUTER PRODUCTS INC.
C     IF MODE=0     IDX=DIRECT CODE;    IDY=REPEAT COUNT
C     IF MODE=1     IDX=LDEV FOR SETUP, =0 FOR RESET;  IDY=DUMMY
C     IF MODE=2     IDX=MULTI-PREC. DX; IDY=MULTI-PREC. DY
C     IF MODE=3     IDX(1)=SYMB STRING; IDY=NO.OF CHARS LEFT-JUSTIFIED
C     IF MODE=4     IDX(1)=SYMB STRING; IDY=NO.OF CHARS RIGHT-JUSTIFIED
C     IF MODE=5     IDX=IDY=DUMMY   SPECIAL CALL TO FORCE DUMP
C     IF MODE=6     IDX=# OF CODES NEEDED IN BUFFER; IDY=DUMMY
C     IF MODE=7     IDX=MULTI-PREC NUM; IDY=# OF CHARS TO OUTPUT
      DIMENSION IDX(1),IBUF(125)
      DIMENSION IXX(3),IYY(3)
      INTEGER ISETUP(50)
      LOGICAL OPEN
C  COMMANDS TO INITIALIZE CALCOMP 1012 PLOTTER
      DATA ISETUP/
C  SET RADIX--RADIX SUPPLIED BELOW
     *  1007,0000,
C  ENABLE DOUBLE BUFFERING
     *  1008,1001,
C  SUPPRESS 3 ECHO CHARACTERS
     *  1008,1002,1003,
C  SET TURNAROUND DELAY TO 0 * 20 MS
     *  1008,1003,1000,
C  GOOD RESPONSE IS "1" AND CR
     *  1008,1004,1002,1003,1000,1000,1013,
C  BAD RESPONSE IS "0" AND CR
     *  1008,1005,1002,1003,1001,1000,1013,
C  RESPONSE REQUEST IS "?"
     *  1008,1006,1001,1003,1015,
C  SELECT NO PEN.  ISSUE 2 NOP"S.
     *  1000,1000,
C  RESET SCALING
     *  1009,1001,
C  END OF SETUP ARRAY
     *   17*0 /
C  COUNT + 1 OF SETUP CHS
      DATA ISCNT/34/
C SET RADIX AND RADIX SQUARED
      DATA N1,N2/64,4096/
      DATA J/0/,JMAX/125/
      DATA OPEN/.FALSE./
C
      IX=IDX(1)
      IY=IDY
      IF (MODE-1) 5,100,5
    5 IF (J) 998,998,10
   10 IF(MODE)998,20,60
C  ----- STUFF CODE INTO BUFFER WITH OFFSET FLAG (+1000)
   20 IBUF(J)=IX+1000
      IY=IY-1
      J=J+1
      IF(J-JMAX)30,30,25
   25 CALL PDMP(IBUF,J)
      J=1
   30 IF(IY) 40,40,20
40    RETURN
C
C  ----- DISPATCH FOR NON-ZERO MODES
   60 GO TO(100,200,300,400,500,600,700),MODE
C            1   2   3   4   5   6   7
C
C  ----- CALL TO SET UP RADIX FOR DELTAS, AND ALLOW OTHER CALLS
C  --- BY SETTING 'J' TO A VALID VALUE (+1)
C  --- CALLED BY PLOTS UPON INITIALIZATION
100   IF (IX) 150,150,110
C                          SETUP - CALL PDMP WITH LDEV
110   CONTINUE
      OPEN=.TRUE.
      IDEVNO=IX
115   CONTINUE
      J=1
      CALL PDMP(IDEVNO,-1)
C             NOW SET UP RADIX IN INITIALIZATION STREAM
      ISETUP(2) = N1-1 +1000
      CALL PDMP(ISETUP,ISCNT)
      RETURN
C                      RESET - CALL PDMP, RESET I/O PARAMETERS
  150 J=0
C                         WAIT TILL ALL SHUT DOWN
      CALL PDMP(0,0)
      IF(OPEN) GO TO 115
      RETURN
C
C     MULTI-PRECISION DELTA MODE
200   KMD = 16
      IXC = 3
      IYC = 3
C  ----- CHECK SIGN OF X-DELTA
      IF (IX)  202,201,204
  201 IF (IY)  206,270,210
  202 IX  = -IX
      KMD = 17
C  ----- CHECK SIGN OF Y-DELTA
  204 IF (IY) 206,210,210
  206 IY  = -IY
      KMD = KMD + 2
C  ----- SET UP DELTA PARTS USING CURRENT RADIX
  210 IXX(1) =  IX/N2
      IXX(2) = MOD( (IX/N1) , N1 )
      IXX(3) = MOD( IX , N1 )
      IYY(1) =  IY/N2
      IYY(2) = MOD( (IY/N1) , N1 )
      IYY(3) = MOD( IY , N1 )
C  ----- NOW CHECK FOR 1 2 OR 3 CHARACTER DELTA
      IF (IXX(1)+IYY(1)) 220,212,220
  212 IF (IXX(2)+IYY(2)) 214,216,214
  214 KMD = KMD + 4
      IXC = 2
      IYC = 2
      GO TO 220
  216 KMD = KMD + 8
      IXC = 1
      IYC = 1
C  ----- NOW CHECK FOR ZERO COMPONENT OF DELTA
  220 IF (IX) 224,222,224
  222 KMD = KMD + 12 + MOD(KMD,4)/2
      IXC = 0
      GO TO 250
224   CONTINUE
      IF(IY) 230,226,230
  226 KMD = KMD + 14 - MOD(KMD,4)*2
      IYC = 0
      GO TO 250
C  ----- NOW CHECK FOR DIFFERENT LENGTH DELTAS
  230 IF (IXC-2) 250,240,231
  231 IF (IXX(1)) 232,233,232
  232 IF (IYY(1)) 250,234,250
  233 IF (IXX(2)) 235,236,235
  234 IF (IYY(2)) 237,238,237
  235 IXC = 2
      KMD = KMD + 24
      GO TO 250
  236 IXC = 1
      KMD = KMD + 28
      GO TO 250
  237 IYC = 2
      KMD = KMD + 32
      GO TO 250
  238 IYC = 1
      KMD = KMD + 36
      GO TO 250
  240 IF (IXX(2)) 242,243,242
  242 IF (IYY(2)) 250,244,250
  243 IXC = 1
      KMD = KMD + 36
      GO TO 250
  244 IYC = 1
      KMD = KMD + 40
C
C  ----- STUFF THE PROPER NUMBER OF CHARACTERS INTO 'IBUF'
C               MAKE SURE THE ENTIRE DELTA WILL FIT IN THIS BUFFER
  250 IF(J+1+IXC+IYC-JMAX) 254,254,252
  252 CALL PDMP(IBUF,J)
      J = 1
  254 IBUF(J) = KMD + 1000
      J = J + 1
C           NOW STUFF X-DELTA, MOST SIGNIFICANT FIRST
      IF (IXC) 998,260,256
  256 K1 = 4 - IXC
      DO 258 K=K1,3
      IBUF(J) = IXX(K) + 1000
  258 J = J + 1
C          NOW STUFF Y-DELTA, MOST SIGNIFICANT FIRST
  260 IF (IYC) 998,270,262
  262 K1 = 4 - IYC
      DO 264 K=K1,3
      IBUF(J) = IYY(K) + 1000
  264 J = J + 1
C         ALL DONE - NOW RETURN
  270 RETURN
C
C     SYMBOL MODE
  300 CONTINUE
C
C  TRAP A MODE 3 OR 4 CALL.
C
C	WRITE(0,997) MODE,IDY
C997	FORMAT(/,' BUFF CALLED WITH MODE =',I2,
C    * ', CHARACTER COUNT =',I3,'.')
C	K1=(IDY+3)/4
C	DO 444 K=1,K1
C	ICH4=IDX(K)
C	II=4
C	IF(K.EQ.K1) II=IDY-4*(K1-1)
C	WRITE(0,'(A,$)') CH4(1:II)
C 444	CONTINUE
C	GO TO 448
  400 CONTINUE
C 	WRITE(0,997) MODE,IDY
C	DO 445 K=1,IDY
C	WRITE(0,'(A,$)') CHAR(IDX(K))
C 445	CONTINUE
C  448 CONTINUE
	K = IY
	K1 = 1
C  ----- FIRST MAKE SURE THERE IS ROOM FOR COMMAND CODE, AND CHARACTER
C  --- COUNT, AND THE FIRST CHARACTER IN THE BUFFER
  401 IF (J+2-JMAX) 410,410,405
C  ----- FLUSH THE BUFFER TO MAKE ROOM
  405 CALL PDMP(IBUF,J)
      J = 1
  410 IF (K-(N1-1)) 420,420,415
  415 K = N1-1
  420 IF (J+K+1-JMAX) 430,430,425
  425 K = JMAX - J - 1
C  ----- NOW STUFF COMMAND CODE AND CHARACTER COUNT
  430 IBUF(J) = 5 + 1000
      IBUF(J+1) =  K + 1000
      J = J+2
      K2 = K + K1 - 1
C                            NOW LOOP STUFFING CHARACTERS
      DO 460 I=K1,K2
      IF (MODE-3) 435,440,435
  435 IBUF(J) = IDX(I)
      GO TO 450
C 440 CALL PACK1 (IDX(1+(I-1)/10),ILOC,1+MOD(I-1,10))
440	ICH4=IDX((I+3)/4)
	II=1+MOD(I-1,4)
	ILOC=ICHAR(CH4(II:II))
	IF(ILOC.EQ.0) ILOC=ICHAR(' ')
      IBUF(J)=ILOC
  450 J = J+1
      IF (J-JMAX) 460,460,455
C                    IF BUFFER FULL, DUMP IT
  455 CALL PDMP(IBUF,J)
      J = 1
  460 CONTINUE
      IF (K2-IY) 470,999,999
  470 K1 = K2 + 1
      K = IY - K2
      GO TO 401
C
C FLUSH BUFFER
  500 IF (J-1) 999,999,510
  510 CALL PDMP(IBUF,J)
      J = 1
      GO TO 999
C
C       TEST FOR ENOUGH ROOM IN THE BUFFER
 600  IF (J+IX-JMAX)  999,999,510
C
C               STORE IX IN IY WORDS OF BUFFER
 700  IXX(1)=IX/N2
      IXX(2)=MOD((IX/N1),N1)
      IXX(3)=MOD(IX,N1)
      IF (J+IY-JMAX) 720,720,710
 710  CALL PDMP(IBUF,J)
      J = 1
 720  K = 4-IY
      DO 725 I=K,3
      IBUF(J) = 1000 + IXX(I)
 725  J = J+1
      GO TO 999
C  STANDARD EXIT
 999  RETURN
C
C *****  THIS EXIT SHOULD NOT BE TAKEN (AN INVALID RETURN)
998   CONTINUE
C     STOP " ILLEGAL EXIT FROM BUFF."
      END
