      SUBROUTINE LINE (XARRAY,YARRAY,NPTS,INC,LINTYP,INTEQ)             
CALCOMP  PRODUCT NUMBER  411010*2-G              EBCDIC PUNCH           
CALCOMP HCBS FOR CDC 6000     906/EM RS-232 ONLINE          JUL, 1979 * 
CALCOMP  COPYRIGHT 1979 CALIFORNIA COMPUTER PRODUCTS INC.               
C.....     XARRAY  NAME OF ARRAY CONTAINING ABSCISSA OR X VALUES.       
C.....     YARRAY  NAME OF ARRAY CONTAINING ORDINATE OR Y VALUES.       
C.....     NPTS    NUMBER OF POINTS TO BE PLOTTED.                      
C.....     INC     INCREMENT OF LOCATION OF SUCCESSIVE POINTS.          
C.....     LINTYP  CONTROL TYPE OF LINE--SYMBOLS, LINE, OR COMBINATION. 
C.....     INTEQ   INTEGER EQUIVALENT OF SYMBOL TO BE USED, IF ANY.     
      DIMENSION XARRAY(1),YARRAY(1)                                     
      LMIN = NPTS*INC+1                                                 
      LDX  = LMIN+INC                                                   
      NL   = LMIN-INC                                                   
      FIRSTX = XARRAY(LMIN)                                             
      DELTAX = XARRAY(LDX)                                              
      FIRSTY = YARRAY(LMIN)                                             
      DELTAY = YARRAY(LDX)                                              
      CALL WHERE (XN,YN,DF)                                             
      DF=AMAX1(ABS((XARRAY( 1)-FIRSTX)/DELTAX-XN),                      
     1         ABS((YARRAY( 1)-FIRSTY)/DELTAY-YN) )                     
      DL=AMAX1(ABS((XARRAY(NL)-FIRSTX)/DELTAX-XN),                      
     1         ABS((YARRAY(NL)-FIRSTY)/DELTAY-YN) )                     
      IPEN = 3                                                          
      ICODE = -1                                                        
      NT =IABS(LINTYP)                                                  
      IF (LINTYP) 7,6,7                                                 
    6 NT = 1                                                            
    7 IF (DF-DL) 9,9,8                                                  
    8 NF = NL                                                           
      NA = ((NPTS-1)/NT)*NT+NT-(NPTS-1)                                 
      KK = -INC                                                         
      GO TO 10                                                          
    9 NF = 1                                                            
      NA = NT                                                           
      KK = INC                                                          
   10 IF (LINTYP) 11,12,13                                              
   11 IPENA = 3                                                         
      ICODEA = -1                                                       
      LSW = 1                                                           
      GO TO 15                                                          
   12 NA=LDX                                                            
   13 IPENA = 2                                                         
      ICODEA = -2                                                       
      LSW=0                                                             
   15 DO 30 I =1,NPTS                                                   
      XN = (XARRAY(NF)-FIRSTX)/DELTAX                                   
      YN = (YARRAY(NF)-FIRSTY)/DELTAY                                   
      IF (NA-NT) 20,21,22                                               
   20 IF (LSW) 23,22,23                                                 
   21 CALL SYMBOL (XN,YN,0.08,INTEQ,0.0,ICODE)                          
      NA = 1                                                            
      GO TO 25                                                          
   22 CALL PLOT (XN,YN,IPEN)                                            
   23 NA = NA + 1                                                       
   25 NF = NF+KK                                                        
      ICODE = ICODEA                                                    
   30 IPEN = IPENA                                                      
      RETURN                                                            
      END                                                               
