	PROGRAM DOPHOT3
	INCLUDE 'TUNEABLE3'
	PARAMETER (NAPPLE = 5)
	COMMON /STARLIST/ STARPAR(NPMAX,NSMAX), IMTYPE(NSMAX),
     1  SHADOW(NPMAX,NSMAX),ERRSHAD(NPMAX,NSMAX)
	COMMON /APERLIST/ APPLE(NAPPLE ,NSMAX)
	COMMON /UNITIZE/ UFACTOR
	COMMON /UNDERGND/ NFAST, NSLOW
	COMMON /CTIMES/ CHIIMP, APERTIME, FILLTIME, ADDTIME
	COMMON /DRFAKE/ NEEDIT
        common /search/ nstot,thresh
	common /probpass/ probg(nsmax)
	LOGICAL NEEDIT
	character*80 header(100)
	CHARACTER*80 FMT3,FMT4
        character*128 outputline
	LOGICAL WARM
	INTEGER*4 IMG(4), NOI(4) 
c-----------------------------------------------------------------------
c  These are added or changed declarations. Nov. 1990.
      integer*2  ibig (ncmax, nrmax)
      integer    noise (ncmax, nrmax)     
      integer    maxdim, imgin, imgout, ieeer, iost, inlen, outlen
      integer    headlen
      external   fpe_handler
c-----------------------------------------------------------------------
	EXTERNAL PSEUD2D, PSEUD4D
	DATA IMG(3), NOI(3) / 98, 99 /		
	DATA NEEDIT / .TRUE. /
C	DATA FMT3 / '(I4, I3, 1P9E11.3,0PF8.2)' /
c	DATA FMT3 / '(I4, I3, 1PE11.4, 0P2F11.2, 1P6E11.3,0P2F8.3)' /
	datafmt3/'(i4,i3,1pe11.4,0p2f11.2,1p6e11.3,0p2f8.3,1p6e11.3)'/
	DATA FMT4 / '(I4, I3, 1PE11.4, 0P2F11.2, 1P6E11.3)' /
C:      DATA ACC / .01, -.03, -.03, .01, .03, .1, .03 /
C:	DATA ALIM / -1.0E8, 2*-1.0E3, -1.0E8, 3*-1.0E3 /

        iost = 0
        logv = 100
        ufactor = 100.0

c  Read the parameter file.
        CALL TUNEUP (files,flags)

c-------------------------------------------------------------------------
c  This was added to trap floating point exceptions. 'Common' exceptions
c  are: invalid, overflow, and division by zero. 

      if (files(21)(1:3) .eq. 'YES') then
         open (unit=1, status='new', file='fpe_trap.log',err=99,
     &         iostat=iost)
         ieeer = ieee_handler ('set', 'common', fpe_handler)
      end if
c-------------------------------------------------------------------------

c  Open log file if desired.
c
      if(lverb.gt.0.and.files(6)(1:4).ne.'TERM') 
     *      call opena(6,files(6),2,ierr)

      lverb = lverb*10 + 1
      nhead = 100

c--------------------------------------------------------------------
c  This section was modified for the IMFORT i/o routines.
c  Open input picture and read the header and data.

      maxdim = ncmax * nrmax
      inlen = 64 
      outlen = 64 
      headlen = 80

      if (files(22)(1:4) .eq. 'FITS') then
         call rffile (nhead, header, nx, ny, ibig, files(1),
     &                            %val(headlen), %val(inlen))
      else if (files(22)(1:4) .eq. 'IRAF') then
         call rdiraf (nhead,header,nx,ny,maxdim,ibig,files(1),imgin)
      end if
c--------------------------------------------------------------------

      nfast = nx
      nslow = ny
c
	WARM = (flags(6)(1:1).eq.'Y')
	CALL MAKENOISE(ibig,noise,NFAST,NSLOW)
	IF (WARM) CALL WARMSTART(PSEUD2D,ibig,noise,NFAST,
     *     NSLOW,files(3))
c
	THRESH = TMIN
2757 	IF (THRESH*2**TFAC .LE. TMAX) THEN
	  THRESH = THRESH*2**TFAC
	GO TO 2757
	END IF
C:
2758 	IF (THRESH/TMIN .GE. 0.999) THEN
C	  SKY = GUESS1(A, STARPAR, IX, IY)			!FOSSIL?
	  if(lverb.gt.10) then
            write(6,*)
            write(6,*) 
     *        'Starting loop at threshold level ', THRESH
          end if
      if(flags(2)(1:5).eq.'PLANE') 
     *     CALL VARIPARPLANE(NSTOT,NFAST,NSLOW)
      if(flags(2)(1:5).eq.'HUBBL') 
     *     CALL VARIPARHUB(NSTOT,NFAST,NSLOW)
	  NSTAR = ISEARCH(PSEUD2D,IBIG,noise,NFAST,NSLOW)
C	  IF (NSTAR .NE. 0) THEN
	    CALL SHAPE(PSEUD2D,PSEUD4D,IBIG,NOISE,NFAST,NSLOW)
	    CALL PARAVG					
	    IF (NSTOT .GE. 1) then
      if(flags(2)(1:5).eq.'PLANE') 
     *     CALL VARIPARPLANE(NSTOT,NFAST,NSLOW)
      if(flags(2)(1:5).eq.'HUBBL') 
     *     CALL VARIPARHUB(NSTOT,NFAST,NSLOW)
            END IF
	    CALL IMPROVE(PSEUD2D,IBIG,NOISE,NFAST,NSLOW)
C	  END IF
c
	  if(lverb.gt.10) then
          write(6,*) ' Ending loop at threshold level ',THRESH
          write(6,*) 
     *    ' Number of new objects found on this threshold = ',NSTAR
          write(6,*)
     *    ' Total number of objects found so far = ',NSTOT
          end if
c
	  THRESH = THRESH/2**TFAC
c
          call opena(3,files(4),2,ierr)
          if(flags(4)(1:1).eq.'Y') call opena(4,files(5),2,ierr)
c
	  DO 2759 I = 1, NSTOT
c
c  Decide what kind of output is needed.
c
          if(flags(3)(1:5).eq.'INTER') then
        WRITE (3, FMT3) I,IMTYPE(I),(STARPAR(J,I),J=1,NPAR),
     *    (APPLE(J,I),J =1,4),probg(i)
          else if(flags(3)(1:5).eq.'COMPL') then
        call stdotpt(i,imtype(i),starpar(1,i),npar,apple(1,i),
     *        napple,probg(i),outputline)
            write(3,'(a)') outputline(1:128)
          else if(flags(3)(1:5).eq.'INCOM') then
        call badotpt(i,imtype(i),starpar(1,i),npar,apple(1,i),
     *         napple,probg(i),outputline)
            write(3,'(a)') outputline(1:80)
          end if
c
		if(flags(4)(1:1) .eq. 'Y') then
	    IF (SHADOW(1,I) .NE. 0) THEN
	      WRITE (4, FMT4) I,IMTYPE(I),(SHADOW(J,I), J = 1, NPAR)
	    ELSE
	      WRITE (4, FMT4) I,IMTYPE(I),(STARPAR(J,I), J = 1, NPAR)
	    END IF
 		end if
2759	  CONTINUE
c
          close(unit=3)
          if(flags(4)(1:1).eq.'Y') close(unit=4)
c
c  Write FITS output file. 
c       
        if ((flags(5)(1:1).eq.'Y') .and. 
     &             (files(22)(1:4) .eq. 'FITS')) then
           call wffile (nhead, header, nx, ny, ibig, files(2),
     &                             %val(headlen), %val(outlen))
        end if
c
	GO TO 2758
	END IF

c---------------------------------------------------------------------
c  This was added to write the IRAF subtracted image file.
      if ((flags(5)(1:1).eq.'Y') .and. 
     &            (files(22)(1:4) .eq. 'IRAF')) then 
         call wriraf (files(2),imgin,imgout,nx,ny,maxdim,ibig) 
      end if 
c---------------------------------------------------------------------

99    if (iost .ne. 0) then
         print *,' Error opening error file : ',iost
         stop 'Abnormal Termination'
      end if

      END
