	SUBROUTINE SHAPE(ONESTAR, TWOSTAR, BIG, NOISE, NFAST, NSLOW)
	PARAMETER (MMAX = 11)
	PARAMETER ( MAXFIL = 1024)
	INCLUDE 'TUNEABLE3'
	COMMON /STARLIST/ STARPAR(NPMAX,NSMAX), IMTYPE(NSMAX),
     1  SHADOW(NPMAX,NSMAX),SHADERR(NPMAX,NSMAX)
	COMMON /SEARCH/ NSTOT, THRESH
	COMMON /SUBRASTER/  Z(MAXFIL), XX(MAXFIL), YE(MAXFIL)
	COMMON /CRUDESTAT/ NPT, SUM1, SUMX, SUMY, MAXVAL
	COMMON/FITARRAYS/A(NPMAX),FA(NPMAX),C(2*NPMAX+1,2*NPMAX+1),
     1	B(2*NPMAX),FB(2*NPMAX)
	COMMON /BYVIRTUE / CHI(4)
	DIMENSION TWOFPAR(NPMAX,NSMAX)
c----------------------------------------------------------------------
c Array noise has been changed to a 32 bit integer array.
c       INTEGER*2 BIG(NFAST,NSLOW), NOISE(NFAST,NSLOW)
        integer*2 big(nfast, nslow)
        integer*4 noise(nfast, nslow)
c----------------------------------------------------------------------
	EXTERNAL ONESTAR,TWOSTAR
	LOGICAL VERYBIG, GALAXY, OFFP, OFFPIC, VFAINT, TOOFAINT
	LOGICAL CONVERGE
	DIMENSION ERR(NPMAX)
	DATA IADD, ISUB / 1, -1 /
	DATA IZERO / 0 /
C:
C:  NEXT WE GO THROUGH PREVIOUSLY IDENTIFIED STARS AND FIT AGAIN
C:
	NSPREV = NSTOT
	I = 1
2757 	IF (I .LE. NSPREV) THEN
	    if(lverb .gt. 20) then
	      write(6,*) ' Determining SHAPE for object No.', I 
	    end if
	  VFAINT = IMTYPE(I) .EQ. 7
	  IF (IMTYPE(I) .EQ. 3) THEN
	    VFAINT = VFAINT .OR. TOOFAINT(STARPAR(1,I), ERR)
	  END IF
	  IF (VFAINT) THEN			
	  if(lverb.gt.20) then
	     write(6,*) 'TOO FAINT, SKIPPING Object #', I, ' at:',
     +          STARPAR(2,I),STARPAR(3,I)
	  end if
	  ELSE IF (IMTYPE(I) .EQ. 4 .or. imtype(i) .eq. 9) THEN
	  if(lverb.gt.20) then
	      write(6,*) ' SKIPPING NONCONVERGER.. Obj#: ', I,
     *            '  AT: ',(STARPAR(J,I),J=2,3)
	  end if
	  ELSE IF (IMTYPE(I) .EQ. 6) THEN	
	  ELSE IF (IMTYPE(I) .EQ. 8) THEN	
	  ELSE
	    CALLADDSTAR(ONESTAR,BIG,NOISE,NFAST,NSLOW,STARPAR(1,I),IADD)
	    IF (SHADOW(1,I) .EQ. 0) THEN
	      SKY = GUESS2 (A, STARPAR(1, I), IX, IY)
	    ELSE
	      SKY = GUESS2 (A, SHADOW(1, I), IX, IY)
	    END IF
	    CALL FILLERUP (BIG, NOISE, IX, IY, NFAST, NSLOW)
	    IF (NPT .LT. ENUFF7*IRECT(1)*IRECT(2)) THEN		
      		if(lverb.gt.20) then 
		   write(6,*) 
     *     ' Obj#, NPTS, IX & IY = ', I, NPT,IX,IY,
     +        '   .... SKIPPIN STAR: not enough pixels for 7-parm fit '
	      IF (IMTYPE(I) .NE. 2) IMTYPE(I) = 5		
	         end if
	      CALLADDSTAR(ONESTAR,BIG,NOISE,NFAST,NSLOW,STARPAR(1,I),ISUB)
	    ELSE
	      if(lverb.gt.20) then
	       write(6,*) ' Obj#, #-PTS FIT, X, Y = ', I, NPT, IX, IY
	      end if
	      GALCHI=CHISQ(ONESTAR,XX,Z,YE,NPT,A,FA,C,NFIT2,ACC,
     *             ALIM,NIT)
	      CALL PARUPD (A, SHADOW(1,I), IX, IY)
	      CALL ERRUPD (C, SHADERR(1,I), NFIT2)
	      VERYBIG = GALAXY(A, SHADERR(1,I), STARPAR(1,I))
	      IF(IMTYPE(I).EQ.3)VERYBIG=VERYBIG.AND.(CHI(4).GT.XTRA)
C	      CONVERGE = GALCHI .LT. 1E5
	      CONVERGE = GALCHI .LT. 1E10
	      OFFP = OFFPIC(A,IX,IY,NFAST,NSLOW,DX,DY)
	      VERYBIG = VERYBIG .AND. (.NOT. OFFP)	
	      VERYBIG = VERYBIG .AND. CONVERGE		
	      IF (.NOT. VERYBIG) THEN
	        IF (IMTYPE(I) .NE. 3) IMTYPE(I) = 1	
		IF (.NOT. CONVERGE) THEN
		  IF (IMTYPE(I) .NE. 3) IMTYPE(I) = 4
	          SHADOW(1,I) = 0			
      		if(lverb.gt.20) then
        write(6,*) 'Obj #', I, ' at', STARPAR(2,I), STARPAR(3,I),
     +   'FAILED TO CONVERGE! '	
	        end if
		ELSE IF (OFFP) THEN
		  IMTYPE(I) = 4				
	          SHADOW(1,I) = 0			
      	    if(lverb.gt.20) then
	   write(6,*) ' ABSURD SHAPE VALUES for Obj #', I, 'at:', 
     +     STARPAR(2,I), STARPAR(3,I)
	   write(6,*) ' Fit center outside fit subraster 
     +            .... DISCARD SOLUTION!'
	    end if
	        END IF
		CALLADDSTAR(ONESTAR,BIG,NOISE,NFAST,NSLOW,STARPAR(1,I),ISUB)
	      ELSE
      		if(lverb.gt.20) then
	         write(6,*) ' Obj #', I, ' at:', STARPAR(2,I),
     +            STARPAR(3,I),  '  is VERY BIG.... '
                 write(6,*) ' . .. Testing GALAXY vs. DBLE-STAR '
	        end if
		CALL TWOUPD(TWOFPAR(1,I), B, -IX, -IY)
		STARCHI=TWOFIT(TWOSTAR, STARPAR(1,I))
        	IF (STARCHI/GALCHI .LT. STOGRAT) THEN	
      		if(lverb.gt.20) then
	          write(6,*) ' Result-> A SPLIT STAR:',
     + ' GAL-CHI:', GALCHI, ' STAR-CHI:', STARCHI
	        end if
		  IMTYPE(I) = 3
		  CALL PARUPD (B, SHADOW(1,I), IX, IY)	
		  CALL PARUPD (B, STARPAR(1,I), IX, IY)
		  CALLADDSTAR(ONESTAR,BIG,NOISE,NFAST,NSLOW,STARPAR(1,I),ISUB)
		  NSTOT = NSTOT + 1
		  IMTYPE(NSTOT) = 3		
		  CALL PARUPD (TWOFPAR(1,NSTOT),TWOFPAR(1,I),IZERO,IZERO)
		  CALL PARUPD (B(NFIT2+1), STARPAR(1,NSTOT), IX, IY)
		  CALLADDSTAR(ONESTAR,BIG,NOISE,NFAST,NSLOW,STARPAR(1,NSTOT),
     1	  		ISUB)
		ELSE
              if(lverb.gt.20) then
	        write(6,*) ' Result-> A GALAXY:', 
     + ' GAL-CHI:', GALCHI, ' STAR-CHI:', STARCHI
	      end if
		  IMTYPE(I) = 2
		  CALL PARUPD (A, STARPAR(1,I), IX, IY)
		  CALL TWOUPD (FB, TWOFPAR(1,I), IX, IY)
		  CALLADDSTAR(ONESTAR,BIG,NOISE,NFAST,NSLOW,STARPAR(1,I),ISUB)
		END IF
	      END IF
	    END IF
	  END IF
	  I = I + 1
	GO TO 2757
	END IF
	RETURN
	END
