procedure hash (input)

string	input			{prompt="List of strings to hash"}
int	MAX_HASHCHARS	= 18	{prompt="Maximum characters to hash"}
int	NTHREADS	= 199	{prompt="Number of threads"}
bool	verbose		= yes	{prompt="Verbose output?"}
int	hash			{prompt="Final hashed value [OUTPUT]"}

string	*list

begin
	int	index = 0

	string	linput, name, tmpfile
	int	lhash, ascii, sum, length, ip

	tmpfile = mktemp ("tmp$tmp")

	linput = input
	files (linput, sort-, > tmpfile)

	if (verbose)
	    print ("num\tname\t\thash\tsum")

	list = tmpfile
	while (fscan (list, name) != EOF) {

	    length = min (strlen (name), MAX_HASHCHARS)
	    index += 1
	    sum = 0

	    for (ip=1; ip <= length; ip+=1) {
		ascii = substr (name, ip, ip)
		sum += sum + ascii
	    }

	    lhash = mod (sum, NTHREADS) + 1

	    if (! verbose)
		print (lhash)
	    else if (length < 8)
		print (index, "\t", name, "\t\t", lhash, "\t", sum)
	    else
		print (index, "\t", name, "\t", lhash, "\t", sum)

	}
	list = ""; delete (tmpfile, ver-, >& "dev$null")

	hash = lhash
end
