include	<mach.h>
include	<gio.h>
include <gset.h>
include	"lblglabax.h"

# LBL_TICKLEN -- Compute the length of a tick in world coordinates.  
# Taken almost entirely from gio$glabax/glbticlen.x (which see), with
# only minor modifications.

real procedure lbl_ticklen (gp, ax, ndc_length)

pointer	gp			# graphics descriptor
pointer	ax			# axis descriptor
real	ndc_length		# length of tick in NDC units

int	wcs
real	x, y, wx, wy
int	gstati()

#debug+
int	debug
common	/deb/ debug
#debug-
begin
	wcs = gstati (gp, G_WCS)
	call gctran (gp, AX_TICK1(ax,1), AX_TICK1(ax,2), x, y, wcs, 0)

	if (AX_HORIZONTAL(ax) == YES)
	    y = y + ndc_length
	else
	    x = x + ndc_length

	call gctran (gp, x, y, wx, wy, 0, wcs)
	if (AX_HORIZONTAL(ax) == YES) {
# These must be in error, no??  (They're also in gio$glabax/glbticlen.x)
#	    call pargr (wy - AX_TICK1(ax,2))
	    return (wy - AX_TICK1(ax,2))
	} else {
#	    call pargr (wx - AX_TICK1(ax,1))
	    return (wx - AX_TICK1(ax,1))
	}
end
