include "lpl.h"

# LPL_ASSIGN_TITLE -- Assign passed title string to appropriate position in
# title pointer.  Keep track of memory allocation.

procedure lpl_assign_title (lpl, title_str, curve)

pointer	lpl			# longplot descriptor, points to title pointer
char	title_str[ARB]		# actual title string
int	curve			# curve number

int	nch, cur_title_len

int	strlen()

begin
	if (curve == 1) {
	    call calloc (LPL_TITLENDX(lpl), MAX_CURVES, TY_INT)
	    cur_title_len = 0
	}

	nch = strlen (title_str)
	call realloc (LPL_TITLE(lpl), cur_title_len + nch + 1, TY_CHAR)

	call strcpy (title_str, TITLE(LPL_TITLE(lpl),cur_title_len),
	    SZ_LINE*4)
	Memi[LPL_TITLENDX(lpl) + curve - 1] = cur_title_len + 1
	cur_title_len = cur_title_len + nch + 1
end
