include "lpx.h"

# LPL_SET_WV -- Set real wcs and viewport from the lpx arrays.

procedure lpl_set_wv (lpx, gd, curve)

pointer	lpx		# arrays containing wmin,max, pmin,max, etc.
pointer	gd		# graphics device descriptor
int	curve		# current curve to be drawn

#debug+
int	debug
common /deb/ debug
#debug-
begin
#debug+
if (debug == YES) {
call eprintf ("set_wv:\n")
call eprintf ("       lpx_wxmin(lpx,%d)=%g,wxmax=%g, wymin=%g,wymax=%g\n")
call pargi (curve-1)
call pargr (LPX_WXMIN(lpx,curve-1))
call pargr (LPX_WXMAX(lpx,curve-1))
call pargr (LPX_WYMIN(lpx,curve-1))
call pargr (LPX_WYMAX(lpx,curve-1))
}
#debug-
	# Set wcs.
	call gswind (gd, LPX_WXMIN(lpx,curve-1),LPX_WXMAX(lpx,curve-1),
	    LPX_WYMIN(lpx,curve-1),LPX_WYMAX(lpx,curve-1))

	# Set viewport.
	call gsview (gd, LPX_VXMIN(lpx,curve-1),LPX_VXMAX(lpx,curve-1),
	    LPX_VYMIN(lpx,curve-1),LPX_VYMAX(lpx,curve-1))
end
