C     SUBROUTINE PLOTS
C
C     PURPOSE
C        TO SET UP CALCOMP PLOT FILE
C
C     USAGE
C        CALL PLOTS(ISF,INDEX,LDEV)
C          ISF    - \
C          INDEX  -  > I DON'T KNOW, CALCOMP HAS REAL GOOD DOCUMENTATION
C          LDEV   - /
C
C     SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED
C        PLOT   - SUBROUTINE TO POSITION PEN
C        SYMBOL - SUBROUTINE TO PLOT A CHARACTER STRING
C
C        GETLOG - UNIX SYSTEM ROUTINE TO GET LOGIN NAME
C        FDATE  - UNIX SYSTEM ROUTINE TO GET DATE AND TIME
C
C     COMMENTS
C        THIS PROGRAM MODIFIED FOR UNIX BSD4.2 BY
C             ED ANDERSON (NOAO), AUGUST, 1985.
C
CALCOMP  PRODUCT NUMBER  411010*2-G              EBCDIC PUNCH
CALCOMP HCBS FOR CDC 6000     906/EM RS-232 ONLINE          JUL, 1979 *
CALCOMP  COPYRIGHT 1979 CALIFORNIA COMPUTER PRODUCTS INC.

      SUBROUTINE PLOTS(ISF,INDEX,LDEV)
      CHARACTER*33 HEADER
      CHARACTER*24 DATE
      CHARACTER*8  USERNAME
      COMMON /HEAD1/HEADER
      USERNAME='        '
      DATE='                        '
      CALL GETLOG(USERNAME)
      CALL FDATE(DATE)
      HEADER=USERNAME // ' ' // DATE
C                  CALL BUFF WITH "SET-UP" PARAMETERS
      CALL BUFF (LDEV,0,1)
      CALL PLOT (FLOAT(-ISF),FLOAT(-INDEX),1007)
C  POSITION THE 1038 AT A KNOWN POSITION.
      CALL PLOT(0.0,-40.0,-3)
      CALL PLOT(0.25,0.5,-3)
      CALL SYMBOL(0.,0.,0.25,HEADER,90.,33)
      CALL WHERE(XPOS,YPOS,FCTR)
      CALL SYMBOL(0.,YPOS+.5,0.25,10HPLOT START,90.,10)
      CALL PLOT(0.5,0.0,-3)
      RETURN
      END
