      PROGRAM SAMPLE
C
C     THIS SAMPLE PLOT PROGRAM WAS RUN ON THE CLASS 6 VMS VAX.
C
      DIMENSION X(50), Y1(50), Y2(50), Y3(50), YDUM(150)
      EQUIVALENCE (Y1(1),YDUM(1)), (Y2(1),YDUM(51)), (Y3(1),YDUM(101))
C
C............................................................INITIALIZE PLOTTING
      CALL PLOTS(0.,0.,5)
C
C.........................................RELOCATE REFERENCE POINT TO (1.0,1.25)
      CALL PLOT(1.0,1.25,-3)
C
C...................................................CALCULATE VALUES FOR X ARRAY
      X(1)=-12.
      DO 10 I=2, 50
         X(I)=X(I-1)+1.
   10 CONTINUE
C
C..................................................CALCULATE VALUES FOR Y ARRAYS
      DO 20 I=1, 50
         Y1(I) = X(I) * X(I)
         Y2(I) = -.5 * X(I) * X(I) + 2. * X(I) - 200.
         Y3(I) = 5. * X(I) + 200.
   20 CONTINUE
C
C.CALCULATE SCALE FACTORS FOR ARRAYS X AND YDUM OVER 5 AND 6 INCHES RESPECTIVELY
      CALL SCALE2(X, 5., 50, 1, 0, XMIN, XDA)
      CALL SCALE2(YDUM, 6., 150, 1, 0, YMIN, YDA)
C
C..........................................................DRAW THE CROSSED AXES
      CALL CRAXES(5., 6., XMIN, XDA, YMIN, YDA, 2, 0.12)
C
C....................................PLOT FUNCTIONS FROM LEFT TO RIGHT AND LABEL
      CALL PLOT((X(1)-XMIN)/XDA,(Y1(1)-YMIN)/YDA,3)
      CALL LINE2(X,XMIN,XDA,Y1,YMIN,YDA,50,1,1,0,0.08,0)
      CALL WHERE(XPOS,YPOS,FCTR)
      XPOS=XPOS+0.1
      YPOX=YPOX-0.1
      CALL SYMBOL(XPOS,YPOS,0.15,6HY1=X*X,0.,6)
C
      CALL PLOT((X(1)-XMIN)/XDA,(Y2(1)-YMIN)/YDA,3)
      CALL LINE2(X,XMIN,XDA,Y2,YMIN,YDA,50,1,1,1,0.08,0)
      CALL WHERE(XPOS,YPOS,FCTR)
      XPOS=XPOS+0.1
      YPOX=YPOX-0.1
      CALL SYMBOL(XPOS,YPOS,0.15,18HY2=-.5*X*X+2*X-200,0.,18)
C
      CALL PLOT((X(1)-XMIN)/XDA,(Y3(1)-YMIN)/YDA,3)
      CALL LINE2(X,XMIN,XDA,Y3,YMIN,YDA,50,1,1,2,0.08,0)
      CALL WHERE(XPOS,YPOS,FCTR)
      XPOS=XPOS+0.1
      YPOX=YPOX-0.1
      CALL SYMBOL(XPOS,YPOS,0.15,10HY3=5*X+200,0.,10)
C
C....................................................................PLOT TITLES
      CALL SYMBOL(1.5,7.,.15,18HON ONE SET OF AXES,0.,18)
      CALL SYMBOL(1.5,7.4,.15,20HTHREE CURVES PLOTTED,0.,20)
C
C.................................................TERMINATE PLOT AND END PROGRAM
      CALL ENDPLOT
      STOP
      END
